> ## Documentation Index
> Fetch the complete documentation index at: https://www.canva.dev/docs/apps/llms.txt
> Use this file to discover all available pages before exploring further.
# Update asset
Update the metadata for an asset in the users Projects.
You can update the name and tags of an asset by specifying its `assetId`. Updating the tags
replaces all existing tags of the asset.
## HTTP method and URL path
PATCH https\://api.canva.com/rest/v1/assets/\{assetId}
This operation is rate limited to 30 requests per minute for each user of your app.
## Authentication and authorization
This endpoint requires a valid access token that acts on behalf of a user. For more information, see [Generate an access token](/docs/apps/rest-apis/reference/authentication/generate-access-token).
### Scopes
The access token must have all the following [scopes](/docs/apps/rest-apis/scopes) (permissions):
* `asset:write`
## Header parameters
Provides credentials to authenticate the request, in the form of a `Bearer` token.
For example: `Authorization: Bearer {token}`
Indicates the media type of the information sent in the request. This must be set to `application/json`.
For example: `Content-Type: application/json`
## Path parameters
The ID of the asset.
## Body parameters
The name of the asset. This is shown in the Canva UI.
When this field is undefined or empty, nothing is updated.
**Maximum length:** `50`
The replacement tags for the asset.
When this field is undefined, nothing is updated.
**Maximum items:** `50`
## Example request
Examples for using the `/v1/assets/{assetId}` endpoint:
```sh
curl --request PATCH 'https://api.canva.com/rest/v1/assets/{assetId}' \
--header 'Authorization: Bearer {token}' \
--header 'Content-Type: application/json' \
--data '{
"name": "My Awesome Upload",
"tags": [
"image",
"holiday",
"best day ever"
]
}'
```
```js
const fetch = require("node-fetch");
fetch("https://api.canva.com/rest/v1/assets/{assetId}", {
method: "PATCH",
headers: {
"Authorization": "Bearer {token}",
"Content-Type": "application/json",
},
body: JSON.stringify({
"name": "My Awesome Upload",
"tags": [
"image",
"holiday",
"best day ever"
]
}),
})
.then(async (response) => {
const data = await response.json();
console.log(data);
})
.catch(err => console.error(err));
```
```java
import java.io.IOException;
import java.net.URI;
import java.net.http.*;
public class ApiExample {
public static void main(String[] args) throws IOException, InterruptedException {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.canva.com/rest/v1/assets/{assetId}"))
.header("Authorization", "Bearer {token}")
.header("Content-Type", "application/json")
.method("PATCH", HttpRequest.BodyPublishers.ofString("{\"name\": \"My Awesome Upload\", \"tags\": [\"image\", \"holiday\", \"best day ever\"]}"))
.build();
HttpResponse response = HttpClient.newHttpClient().send(
request,
HttpResponse.BodyHandlers.ofString()
);
System.out.println(response.body());
}
}
```
```py
import requests
headers = {
"Authorization": "Bearer {token}",
"Content-Type": "application/json"
}
data = {
"name": "My Awesome Upload",
"tags": [
"image",
"holiday",
"best day ever"
]
}
response = requests.patch("https://api.canva.com/rest/v1/assets/{assetId}",
headers=headers,
json=data
)
print(response.json())
```
```csharp
using System.Net.Http;
var client = new HttpClient();
var request = new HttpRequestMessage
{
Method = HttpMethod.Patch,
RequestUri = new Uri("https://api.canva.com/rest/v1/assets/{assetId}"),
Headers =
{
{ "Authorization", "Bearer {token}" },
},
Content = new StringContent(
"{\"name\": \"My Awesome Upload\", \"tags\": [\"image\", \"holiday\", \"best day ever\"]}",
Encoding.UTF8,
"application/json"
),
};
using (var response = await client.SendAsync(request))
{
response.EnsureSuccessStatusCode();
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
};
```
```go
package main
import (
"fmt"
"io"
"net/http"
"strings"
)
func main() {
payload := strings.NewReader(`{
"name": "My Awesome Upload",
"tags": [
"image",
"holiday",
"best day ever"
]
}`)
url := "https://api.canva.com/rest/v1/assets/{assetId}"
req, _ := http.NewRequest("PATCH", url, payload)
req.Header.Add("Authorization", "Bearer {token}")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
```
```php
$curl = curl_init();
curl_setopt_array($curl, array(
CURLOPT_URL => "https://api.canva.com/rest/v1/assets/{assetId}",
CURLOPT_CUSTOMREQUEST => "PATCH",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array(
'Authorization: Bearer {token}',
'Content-Type: application/json',
),
CURLOPT_POSTFIELDS => json_encode([
"name" => "My Awesome Upload",
"tags" => [
"image",
"holiday",
"best day ever"
]
])
));
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if (empty($err)) {
echo $response;
} else {
echo "Error: " . $err;
}
```
```ruby
require 'net/http'
require 'uri'
url = URI('https://api.canva.com/rest/v1/assets/{assetId}')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Patch.new(url)
request['Authorization'] = 'Bearer {token}'
request['Content-Type'] = 'application/json'
request.body = <
## Success response
If successful, the endpoint returns a `200` response with a JSON body with the following parameters:
The asset object, which contains metadata about the asset.
Properties of asset>} defaultExpanded={true}>
Type of an asset.
**Available values:**
* `image`
* `video`
The ID of the asset.
The name of the asset.
The user-facing tags attached to the asset.
Users can add these tags to their uploaded assets, and they can search their uploaded
assets in the Canva UI by searching for these tags. For information on how users use
tags, see the
[Canva Help Center page on asset tags](https://www.canva.com/help/add-edit-tags/).
When the asset was added to Canva, as a Unix timestamp (in seconds since the Unix
Epoch).
When the asset was last updated in Canva, as a Unix timestamp (in seconds since the
Unix Epoch).
Metadata for the user, consisting of the User ID and Team ID.
Properties of owner>}>
The ID of the user.
The ID of the user's Canva Team.
A thumbnail image representing the object.
Properties of thumbnail>}>
The width of the thumbnail image in pixels.
The height of the thumbnail image in pixels.
A URL for retrieving the thumbnail image.
This URL expires after 15 minutes. This URL includes a query string
that's required for retrieving the thumbnail.
Type-specific metadata for the asset.
**Available values:** The only valid value is `image`.
The width of the image in pixels.
The height of the image in pixels.
AI-generated tags for the image.
**Available values:** The only valid value is `video`.
The width of the video in pixels.
The height of the video in pixels.
The duration of the video in seconds.
The import status of the asset.
Properties of import_status>}>
State of the import job for an uploaded asset.
**Available values:**
* `failed`
* `in_progress`
* `success`
If the import fails, this object provides details about the error.
Properties of error>}>
A human-readable description of what went wrong.
A short string indicating why the upload failed. This field can be used to handle errors programmatically.
**Available values:**
* `file_too_big`
* `import_failed`
## Example response
```json
{
"asset": {
"type": "image",
"id": "Msd59349ff",
"name": "My Awesome Upload",
"tags": [
"image",
"holiday",
"best day ever"
],
"created_at": 1377396000,
"updated_at": 1692928800,
"owner": {
"user_id": "auDAbliZ2rQNNOsUl5OLu",
"team_id": "Oi2RJILTrKk0KRhRUZozX"
},
"thumbnail": {
"width": 595,
"height": 335,
"url": "https://document-export.canva.com/Vczz9/zF9vzVtdADc/2/thumbnail/0001.png?"
},
"metadata": {
"type": "image",
"width": 1920,
"height": 1080,
"smart_tags": [
"landscape",
"sunset",
"mountains",
"nature"
]
}
}
}
```
## Error responses
### 403 Forbidden
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error response
##### Not allowed to update the asset
```json
{
"code": "permission_denied",
"message": "Not allowed to update this asset"
}
```
### 404 Not Found
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error response
##### The asset was not found
```json
{
"code": "asset_not_found",
"message": "Asset not found"
}
```